package top.lichx.webclassbackend.config;

import jakarta.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;
import top.lichx.webclassbackend.interceptor.JwtInterceptor;

@Configuration
@Slf4j
public class WebConfig implements WebMvcConfigurer {
    @Resource
    private JwtInterceptor jwtInterceptor;

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        log.info("addInterceptors");
        registry.addInterceptor(jwtInterceptor)
                .addPathPatterns("/**") // 拦截所有路径
                .excludePathPatterns("/login/**") // 放行登录接口
                .excludePathPatterns("/file/uploadAvatar") // 放行头像上传接口
                .excludePathPatterns("/error/**"); // 放行错误处理接口
    }
}