package top.lichx.webclassbackend.controller;

import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import top.lichx.webclassbackend.pojo.vo.AvatarInfoVO;
import top.lichx.webclassbackend.result.Result;
import top.lichx.webclassbackend.util.COSIO;

import java.io.File;
import java.io.IOException;
import java.net.URL;

@RestController
@RequestMapping("/file")
public class FileController {

    @Resource
    private COSIO cosio;

    @GetMapping("/test")
    public String test() {
        // 使用注入的 COSIO 实例
        System.out.println("COSIO: " + cosio);
        return "test";
    }

//    @PostMapping("/upload")
//    public Result<?> uploadFile(@RequestParam("file") MultipartFile multipartFile) {
//        try {
//            // 将 MultipartFile 转换为 File
//            var file = File.createTempFile("upload-", multipartFile.getOriginalFilename());
//            multipartFile.transferTo(file);
//
//            // 调用 COSIO 的上传方法
//            String filename = cosio.UploadFile(file);
//
//            // 删除临时文件
//            file.delete();
//
//            return Result.success("文件上传成功，文件路径：", filename);
//        } catch (IOException e) {
//            e.printStackTrace();
//            // 处理文件上传失败的情况
//            return Result.error("文件上传失败：" + e.getMessage());
//        }
//    }


    @PostMapping("/uploadAvatar")
    public Result<?> uploadAvatar(@RequestParam("file") MultipartFile multipartFile) throws IOException {
        var file = File.createTempFile("upload-", multipartFile.getOriginalFilename());
        multipartFile.transferTo(file);
        var fileName = cosio.UploadFile(file);
        file.delete();
        var fileURL = cosio.GetFileLink(fileName);
        var avatarInfo = new AvatarInfoVO(fileName, fileURL);
        return Result.success("文件上传成功", avatarInfo);
    }

    @GetMapping("/getFileLink")
    public Result<?> getFileLink(@RequestParam String fileName) {
        URL url = cosio.GetFileLink(fileName);
        return Result.success("获取文件链接成功", url.toString());
    }

}