package top.lichx.webclassbackend.controller;

import jakarta.annotation.Resource;
import jakarta.mail.MessagingException;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.web.bind.annotation.*;
import top.lichx.webclassbackend.pojo.dto.LoginDTO;
import top.lichx.webclassbackend.pojo.dto.PasswordResetDTO;
import top.lichx.webclassbackend.pojo.dto.RegisterDTO;
import top.lichx.webclassbackend.pojo.entity.User;
import top.lichx.webclassbackend.result.Result;
import top.lichx.webclassbackend.service.IdentifyingCode;
import top.lichx.webclassbackend.service.UserService;
import top.lichx.webclassbackend.util.JwtUtil;
import top.lichx.webclassbackend.util.MailUtil;
import top.lichx.webclassbackend.util.PasswordUtil;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Random;

@RestController
@RequestMapping("/login")
public class Login {

    private String mailTemplate = """
            <body>
                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                    <tbody>
                        <tr>
                            <td class="p-80 mpy-35 mpx-15" bgcolor="#FFFFFF" style="padding: 80px;">
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                    <tbody>
                                        <tr>
                                            <td>
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                    <tbody>
                                                        <tr>
                                                            <td
                                                                style="font-size:20px; line-height:42px; font-family:Arial, sans-serif, 'Motiva Sans'; text-align:left; padding-bottom: 30px; color:#002333; font-weight:bold;">
                                                                <span style="color: #007aff;">您好</span>
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                    <tbody>
                                                        <tr>
                                                            <td class="text-18 c-grey4 pb-30"
                                                                style="font-size:18px; line-height:25px; font-family:Arial, sans-serif, 'Motiva Sans'; text-align:left; color:#002333; padding-bottom: 30px;">
                                                                {tip}，有效时间为 {ExpireTime} 分钟。
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                    <tbody>
                                                        <tr>
                                                            <td class="pb-70 mpb-50" style="padding-bottom: 70px;">
                                                                <table width="100%" border="0" cellspacing="0" cellpadding="0"
                                                                       bgcolor="#eaebff">
                                                                    <tbody>
                                                                        <tr>
                                                                            <td class="py-30 px-56"
                                                                                style="padding-top: 30px; padding-bottom: 30px; padding-left: 56px; padding-right: 56px;">
                                                                                <table width="100%" border="0" cellspacing="0"
                                                                                       cellpadding="0">
                                                                                    <tbody>
                                                                                        <tr>
                                                                                            <td style="font-size:18px; line-height:25px; font-family:Arial, sans-serif, 'Motiva Sans'; color:#8f98a0; text-align:center;">
                                                                                                验证码
                                                                                            </td>
                                                                                        </tr>
                                                                                        <tr>
                                                                                            <td style="padding-bottom: 16px"></td>
                                                                                        </tr>
                                                                                        <tr>
                                                                                            <td class="title-48 c-blue1 fw-b a-center"
                                                                                                style="font-size:48px; line-height:52px; font-family:Arial, sans-serif, 'Motiva Sans'; color:#007aff; font-weight:bold; text-align:center;">
                                                                                                {Captcha}
                                                                                            </td>
                                                                                        </tr>
                                                                                    </tbody>
                                                                                </table>
                                                                            </td>
                                                                        </tr>
                                                                    </tbody>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                </table>
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                    <tbody>
                                                        <tr>
                                                            <td class="title-36 pb-30 c-grey6 fw-b"
                                                                style="font-size:30px; line-height:34px; font-family:Arial, sans-serif, 'Motiva Sans'; text-align:left; padding-bottom: 20px; color:#002333; font-weight:bold;">
                                                                不是您？
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                    <tbody>
                                                        <tr>
                                                            <td class="text-18 c-grey4 pb-30"
                                                                style="font-size:18px; line-height:25px; font-family:Arial, sans-serif, 'Motiva Sans'; text-align:left; color:#002333; padding-bottom: 30px;">
                                                               \s
                                                                如果这不是来自您的验证请求，请您忽略本邮件并<span style="color: #002333; font-weight: bold;">不要将验证码转发给任何人</span>。<br><br>
                                                                此电子邮件包含一个代码，您需要用它验证您的帐户。切勿与任何人分享此代码。
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                    <tbody>
                                                        <tr>
                                                            <td class="pt-30" style="padding-top: 30px;">
                                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                                    <tbody>
                                                                        <tr>
                                                                            <td class="img" width="3" bgcolor="#007aff"
                                                                                style="font-size:0pt; line-height:0pt; text-align:left;">
                                                                            </td>
                                                                            <td class="img" width="37"
                                                                                style="font-size:0pt; line-height:0pt; text-align:left;">
                                                                            </td>
                                                                            <td>
                                                                                <table width="100%" border="0" cellspacing="0"
                                                                                       cellpadding="0">
                                                                                    <tbody>
                                                                                        <tr>
                                                                                            <td class="text-16 py-20 c-grey4 fallback-font"
                                                                                                style="font-size:16px; line-height:22px; font-family:Arial, sans-serif, 'Motiva Sans'; text-align:left; padding-top: 20px; padding-bottom: 20px; color:#002333;">
                                                                                                祝您愉快，<br>
                                                                                                Lichx
                                                                                            </td>
                                                                                        </tr>
                                                                                    </tbody>
                                                                                </table>
                                                                            </td>
                                                                        </tr>
                                                                    </tbody>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                        </tr>
                        <tr>
                        </tr>
                    </tbody>
                </table>
            </body>
            """;
//    @Resource
//    private Test test;

    @Resource
    private MailUtil mailUtil;

    @Resource
    private IdentifyingCode identifyingCode;

    @Resource
    private UserService userService;

    @Resource
    private PasswordUtil passwordUtil;

//    @GetMapping("/test")
//    public String test() {
//        test.test();
//        return "test";
//    }
//
//    @PostMapping("/test/{id}")
//    public String testPost(@PathVariable Integer id) {
//        test.test();
//        return "testPost";
//    }

    @PostMapping("/")
    public Result<?> login(@RequestBody LoginDTO loginInfo, HttpServletResponse response) {
        // 验证用户名和密码（此处省略具体逻辑）
        String usernameOrEmail = loginInfo.getUsernameOrEmail();
        String password = loginInfo.getPassword();
        var user = usernameOrEmail.contains("@")?userService.getUserByEmail(usernameOrEmail) : userService.getUserByUserName(usernameOrEmail);
        if (user != null && passwordUtil.matches(password,user.getPassword())) {
            String token = JwtUtil.generateToken(user.getName());
            // 设置HttpOnly和Secure属性的Cookie
            response.setHeader("Set-Cookie", "Authorization=Bearer " + token + "; HttpOnly; Secure; Max-Age=86400; Path=/; SameSite=Strict");
//            response.setHeader("Set-Cookie", "token=Bearer " + token + "; HttpOnly; Secure; Path=/; SameSite=Strict");
            return Result.success("登录成功");
        }
        return Result.error("用户名或密码错误");
    }

    @GetMapping("/logout")
    public Result<?> logout(HttpServletResponse response) {
        // 清除Cookie
        response.setHeader("Set-Cookie", "Authorization=; HttpOnly; Max-Age=0; Path=/; SameSite=Strict");
        return Result.success("注销成功");
    }

    @GetMapping("/register/identifyingCode")
    public Result<?> registerIdentifyingCode(String email) throws MessagingException {
        var captcha = identifyingCode.getIdentifyingCode(email, IdentifyingCode.IdentifyingCodeType.REGISTER, 15 * 60);
        if (captcha == null) {
            return Result.error("验证码请求过于频繁，请稍后再试");
        }
        String mailTemplate = this.mailTemplate;
        String tip = "您正在进行注册操作，这是您验证帐户所需的令牌验证码";
        String expireTime = "15";
        mailTemplate = mailTemplate.replace("{tip}", tip);
        mailTemplate = mailTemplate.replace("{Captcha}", captcha);
        mailTemplate = mailTemplate.replace("{ExpireTime}", expireTime);
        mailUtil.sendHtmlEmail(
                email,
                "Lichx's WebClass",
                mailTemplate);
        return Result.success("验证码已发送到您的邮箱，请注意查收");
    }

    @PostMapping("/register")
    public Result<?> register(@RequestBody RegisterDTO registerDTO) {
        var user = new User();
        user.setId(userService.getUserLastId());
        user.setName(registerDTO.getUsername());
        user.setPassword(passwordUtil.encrypt(registerDTO.getPassword()));
        user.setEmail(registerDTO.getEmail());
        user.setBirth(LocalDate.parse(registerDTO.getBirth(), DateTimeFormatter.ISO_LOCAL_DATE).atStartOfDay());
        user.setAvatarPath(registerDTO.getAvatarFile());
        Random random = new Random();
        int randomNumber = 100 + random.nextInt(901);
        String randomString = Integer.toString(randomNumber);
        user.setAmount(randomString);

        if (!identifyingCode.testIdentifyingCode(registerDTO.getEmail(),
                IdentifyingCode.IdentifyingCodeType.REGISTER,
                registerDTO.getIdentifyingCode())) {
            return Result.error("验证码错误或已过期");
        }
        if (userService.getUserByUserName(user.getName()) != null) {
            return Result.error("用户名已存在");
        }
        userService.insertUser(user);
        return Result.success("用户已注册");
    }

    @GetMapping("/passwordReset/identifyingCode")
    public Result<?> resetIdentifyingCode(String usernameOrEmail) throws MessagingException {
        var email = usernameOrEmail.contains("@") ? usernameOrEmail : userService.getUserByUserName(usernameOrEmail).getEmail();
        var captcha = identifyingCode.getIdentifyingCode(email, IdentifyingCode.IdentifyingCodeType.PASSWORD_RESET, 15 * 60);
        if (captcha == null) {
            return Result.error("验证码请求过于频繁，请稍后再试");
        }
        String mailTemplate = this.mailTemplate;
        String tip = "您正在进行密码重置操作，这是您验证帐户所需的令牌验证码";
        String expireTime = "15";
        mailTemplate = mailTemplate.replace("{tip}", tip);
        mailTemplate = mailTemplate.replace("{Captcha}", captcha);
        mailTemplate = mailTemplate.replace("{ExpireTime}", expireTime);
        mailUtil.sendHtmlEmail(
                email,
                "Lichx's WebClass",
                mailTemplate);
        return Result.success("验证码已发送到您的邮箱，请注意查收");
    }

    @PostMapping("/passwordReset")
    public Result<?> passwordReset(@RequestBody PasswordResetDTO passwordResetDTO) {
        System.out.println();
        String usernameOrEmail = passwordResetDTO.getUsernameOrEmail();
        String password = passwordResetDTO.getPassword();
        var user = usernameOrEmail.contains("@")?userService.getUserByEmail(usernameOrEmail) : userService.getUserByUserName(usernameOrEmail);
        if (!identifyingCode.testIdentifyingCode(user.getEmail(),
                IdentifyingCode.IdentifyingCodeType.PASSWORD_RESET,
                passwordResetDTO.getIdentifyingCode())) {
            return Result.error("验证码错误或已过期");
        }
        userService.changeUserPasswordByUserName(user.getName(), passwordUtil.encrypt(password));
        return Result.success("密码已重置");
    }
}
