package top.lichx.webclassbackend.result;

import lombok.Data;

import java.io.Serializable;

@Data
public class Result<T> implements Serializable {
    private Integer code;
    private String message;
    private T data;

    public static <T> Result<T> success() {
        Result<T> result = new Result<>();
        result.setCode(200);
        result.setMessage("success");
        result.data = null;
        return result;
    }

    public static <T> Result<T> success(String msg) {
        Result<T> result = new Result<>();
        result.setCode(200);
        result.setMessage(msg);
        result.data = null;
        return result;
    }

    public static <T> Result<T> success(String msg, T data) {
        Result<T> result = new Result<>();
        result.setCode(200);
        result.setMessage(msg);
        result.setData(data);
        return result;
    }

    public static Result<Object> error() {
        Result<Object> result = new Result<>();
        result.setCode(500);
        result.setMessage("error");
        return result;
    }

    public static Result<Object> error(String msg) {
        Result<Object> result = new Result<>();
        result.setCode(500);
        result.setMessage(msg);
        return result;
    }
}
