package top.lichx.webclassbackend.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import top.lichx.webclassbackend.mapper.userManagerInfoMapper;
import top.lichx.webclassbackend.pojo.entity.UserManagerInfo;
import top.lichx.webclassbackend.service.UserManagerService;
@Service
public class UserManagerServiceImpl implements UserManagerService {
    @Resource
    private userManagerInfoMapper userManagerInfoMapper;
    public void insertUserManagerInfo(UserManagerInfo userManagerInfo) {
        // 插入用户信息
        userManagerInfoMapper.insert(userManagerInfo);
    }

    public void updateUserManagerInfo(UserManagerInfo userManagerInfo) {
        // 更新用户信息
        userManagerInfoMapper.updateById(userManagerInfo);
    }

    public void deleteUserManagerInfo(Integer id) {
        // 删除用户信息
        userManagerInfoMapper.deleteById(id);
    }

    public IPage<UserManagerInfo> getUserManagerInfoPage(int page, int size, String situation) {
        // 使用 MyBatis-Plus 提供的分页功能
        Page<UserManagerInfo> pageRequest = new Page<>(page, size);
        QueryWrapper<UserManagerInfo> queryWrapper = new QueryWrapper<>();

        // 如果 situation 不为空，则添加模糊查询条件
        if (situation != null && !situation.trim().isEmpty()) {
            queryWrapper.like("name", situation);
        }

        return userManagerInfoMapper.selectPage(pageRequest, queryWrapper);
    }

    public Integer getUserManagerInfoLastId() {
        UserManagerInfo lastRecord = userManagerInfoMapper.selectOne(
                new QueryWrapper<UserManagerInfo>().orderByDesc("id").last("LIMIT 1")
        );
        // 如果记录为空，返回 0，否则返回最后一条记录的 ID
        return lastRecord == null ? 0 : lastRecord.getId() + 1;
    }

    @Override
    public Integer getTotal(String situation) {
        QueryWrapper<UserManagerInfo> queryWrapper = new QueryWrapper<>();
        if (situation != null && !situation.trim().isEmpty()) {
            queryWrapper.like("name", situation);
        }
        return userManagerInfoMapper.selectCount(queryWrapper).intValue();
    }

}
